
import {system,world, MolangVariableMap, Vector, Location} from "@minecraft/server";

function Between(n0, n1) {
        return Math.random() * (n1 - n0) + n0;
  };

function spawnParticle(options){
	let { id, variables, target } = options;
	let molang = new MolangVariableMap();
	for(let variable in variables){
		molang[variables[variable].type](variable,...variables[variable].values);
	};
	target.dimension.spawnParticle(id, new Location(...Object.values(target.location)), molang);
};
world.events.entityCreate.subscribe((e)=>{
	if(!e.entity.hasComponent("minecraft:health")) return;
	e.entity.has_health = true;
	e.entity.stored_health = (e.entity.getComponent("minecraft:health")?.current??0);
	
});
world.events.tick.subscribe((e)=>{
	const players = world.getPlayers();
	for(const player of players){
		for(const entity of player.dimension.getEntities({excludeTypes: ["add:health_indicator"] })){
			if(!entity.has_health) continue;
			let current = entity.getComponent("minecraft:health").current;
			if(current != entity.stored_health){
				
				let result = Math.floor(current) - Math.floor(entity.stored_health);
				
				if(result>0){
				spawnParticle({
					id: "add:recover_health_emitter",
					variables: {
						"variable.recovered_amount": { type: "setVector3", values: [ new Vector(result,result,result) ] }
                    },
					target: {
						dimension: entity.dimension,
						location: { x: entity.location.x, y: entity.location.y+1, z: entity.location.z }
					}
                });
				
				let amount= entity.dimension.spawnEntity("add:health_indicator", new Location(entity.location.x+Between(-1,1.5),entity.location.y+Between(0.5,1), entity.location.z+(-1,1.5)));
               amount.nameTag=`§a+${result}`;
               }
               entity.stored_health = current;
			}
		}
	}
});
world.events.entityHurt.subscribe((e)=>{
	let {hurtEntity, damage} = e;
	
	spawnParticle({
		id: "add:damage_heart_emitter",
		variables: {
			"variable.damage_amount": { type: "setVector3", values: [ new Vector(damage??0,damage??0,damage??0) ] }
		},
		target: { dimension: hurtEntity.dimension, location: { x: hurtEntity.location.x, y: hurtEntity.location.y+1, z: hurtEntity.location.z} }
    });
    let amount= hurtEntity.dimension.spawnEntity("add:health_indicator", new Location(hurtEntity.location.x+Between(-1,1.5),hurtEntity.location.y+Between(0.5,1), hurtEntity.location.z+(-1,1.5)));
    amount.nameTag=`§c${damage*-1}`;
});

system.events.beforeWatchdogTerminate.subscribe((e)=>{
	e.cancel = true;
});